summaryrefslogtreecommitdiffstats
path: root/src/dtc/tests/dtc-checkfails.sh
diff options
context:
space:
mode:
Diffstat (limited to 'src/dtc/tests/dtc-checkfails.sh')
-rwxr-xr-xsrc/dtc/tests/dtc-checkfails.sh44
1 files changed, 44 insertions, 0 deletions
diff --git a/src/dtc/tests/dtc-checkfails.sh b/src/dtc/tests/dtc-checkfails.sh
new file mode 100755
index 0000000..76ded15
--- /dev/null
+++ b/src/dtc/tests/dtc-checkfails.sh
@@ -0,0 +1,44 @@
+#! /bin/sh
+
+. ./tests.sh
+
+for x; do
+ shift
+ if [ "$x" = "-n" ]; then
+ for x; do
+ shift
+ if [ "$x" = "--" ]; then
+ break;
+ fi
+ NOCHECKS="$NOCHECKS $x"
+ done
+ break;
+ fi
+ if [ "$x" = "--" ]; then
+ break;
+ fi
+ YESCHECKS="$YESCHECKS $x"
+done
+
+LOG=tmp.log.$$
+rm -f $LOG
+trap "rm -f $LOG" 0
+
+verbose_run_log "$LOG" $VALGRIND "$DTC" -o /dev/null "$@"
+ret="$?"
+
+FAIL_IF_SIGNAL $ret
+
+for c in $YESCHECKS; do
+ if ! grep -E "^(ERROR)|(Warning) \($c\):" $LOG > /dev/null; then
+ FAIL "Failed to trigger check \"$c\""
+ fi
+done
+
+for c in $NOCHECKS; do
+ if grep -E "^(ERROR)|(Warning) \($c\):" $LOG > /dev/null; then
+ FAIL "Incorrectly triggered check \"$c\""
+ fi
+done
+
+PASS
OpenPOWER on IntegriCloud